/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameter;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameterUK;

public abstract class AbstractBenutzerParameterDAO extends de.ivu.elect.jee.entity.AbstractDAO<BenutzerParameter,
        de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameterPK
    , BenutzerParameterUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractBenutzerParameterDAO.class);

  public AbstractBenutzerParameterDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameterPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public BenutzerParameter findByPrimaryKey(
        de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameterPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected BenutzerParameter findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(BenutzerParameter.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: BenutzerNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM BenutzerParameter o WHERE o.benutzer=?1<br>
      * SQL: <br>
      */
     public java.util.List<BenutzerParameter> findByBenutzer( @javax.annotation.Nonnull de.ivu.elect.business.benutzerverwaltung.entity.Benutzer benutzer) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.benutzerverwaltung.entity.Benutzer benutzerCheckedAndAttached =  checkAndAttach(benutzer, de.ivu.elect.business.benutzerverwaltung.entity.Benutzer.class, "benutzer"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("BENUTZER_PARAMETER.Benutzer")
                              .setParameter(1, benutzerCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByBenutzer - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("BenutzerParameter, findByBenutzer - NonUniqueResultException, Parameter: "
           + ", benutzer:'"+benutzer+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByBenutzer(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: BenutzerSchluesselNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM BenutzerParameter o WHERE o.benutzer=?1 AND o.schluessel=?2<br>
      * SQL: <br>
      */
     public BenutzerParameter findByBenutzerSchluessel( @javax.annotation.Nonnull de.ivu.elect.business.benutzerverwaltung.entity.Benutzer benutzer,  @javax.annotation.Nonnull String schluessel) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.benutzerverwaltung.entity.Benutzer benutzerCheckedAndAttached =  checkAndAttach(benutzer, de.ivu.elect.business.benutzerverwaltung.entity.Benutzer.class, "benutzer"); ;
		  			  String schluesselCheckedAndAttached =  checkAndAttach(schluessel, String.class, "schluessel"); ;
		  
                              return
                    (BenutzerParameter)
                              getEntityManager().
                                createNamedQuery("BENUTZER_PARAMETER.BenutzerSchluessel")
                              .setParameter(1, benutzerCheckedAndAttached)
                                        .setParameter(2, schluesselCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByBenutzerSchluessel - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("BenutzerParameter, findByBenutzerSchluessel - NonUniqueResultException, Parameter: "
           + ", benutzer:'"+benutzer+"'"
           + ", schluessel:'"+schluessel+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByBenutzerSchluessel(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameterUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameterUK uk,
        de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameterPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameter findByUK(de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameterUK uk){

    try {
     return (de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameter) getEntityManager().createNamedQuery("BENUTZER_PARAMETER.UK")
                  .setParameter(1, uk
                .getSchluessel ()  
              )
             .setParameter(2, uk
                .getBenutzerUK ()  
                .getBenutzerkennung ()  
              )
             .setParameter(3, uk
                .getBenutzerUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("BenutzerParameter, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}